UIPackage
Menu

Framework

Change language

Boilerplate repo

Beeswarm Chart

beeswarm-chartui

Beeswarm (jittered strip) plot around Apache ECharts. One dot per observation grouped on rows with deterministic jitter. Theme-aware via registry tokens.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/beeswarm-chart.json
Named registry:npx shadcn-vue@latest add @uipkge/beeswarm-chartInstalls to:app/components/ui/charts/beeswarm-chart/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
dataRecord<string, any>[]required
valueFieldstring'value'optional
groupFieldstring'group'optional
heightnumber | string300optional
optionanyoptional
classstringoptional
ariaLabel

Accessible name announced for the chart image. Defaults to "Chart".

stringoptional

npm dependencies

Used by

Files installed (3)

  • app/components/ui/charts/beeswarm-chart/BeeswarmChart.vue3.8 kB
    <script setup lang="ts">
    import { computed } from 'vue'
    import { use } from 'echarts/core'
    import { CanvasRenderer } from 'echarts/renderers'
    import { ScatterChart as EChartsScatterChart } from 'echarts/charts'
    import { GridComponent, TooltipComponent, LegendComponent } from 'echarts/components'
    import VChart from 'vue-echarts'
    import { cn } from '@/lib/utils'
    import {
      chartColors,
      chartTextColor,
      chartAxisColor,
      chartSplitLineColor,
      chartTooltipBg,
      chartTooltipBorder,
      chartTooltipText,
      mergeOptionBlock,
    } from '../useChartTheme'
    
    use([CanvasRenderer, EChartsScatterChart, GridComponent, TooltipComponent, LegendComponent])
    
    // Deterministic jitter so SSR + client render identical points.
    function jitter(i: number, salt: number) {
      const x = Math.sin(i * 127.1 + salt * 311.7) * 43758.5453
      return (x - Math.floor(x) - 0.5) * 0.72
    }
    
    interface Props {
      data: Record<string, any>[]
      valueField?: string
      groupField?: string
      height?: number | string
      option?: any
      class?: string
      /** Accessible name announced for the chart image. Defaults to "Chart". */
      ariaLabel?: string
    }
    
    const props = withDefaults(defineProps<Props>(), {
      valueField: 'value',
      groupField: 'group',
      height: 300,
    })
    
    const mergedOption = computed(() => {
      const groups = [...new Set(props.data.map((d) => String(d[props.groupField])))]
      const series = groups.map((g, gi) => ({
        name: g,
        type: 'scatter',
        symbolSize: 9,
        itemStyle: { color: chartColors.value[gi % chartColors.value.length], opacity: 0.8 },
        data: props.data
          .map((d, i) => ({ d, i }))
          .filter(({ d }) => String(d[props.groupField]) === g)
          .map(({ d, i }) => [d[props.valueField], gi + jitter(i, gi)]),
      }))
      const userOption: any = props.option ?? {}
      const {
        series: userSeries,
        xAxis: userXAxis,
        yAxis: userYAxis,
        grid: userGrid,
        tooltip: userTooltip,
        legend: userLegend,
        ...userRest
      } = userOption
      const mergedSeries = Array.isArray(userSeries) ? series.map((s, i) => ({ ...s, ...(userSeries[i] ?? {}) })) : series
      return {
        color: chartColors.value,
        grid: mergeOptionBlock(
          { left: 16, right: 16, top: 24, bottom: groups.length > 1 ? 32 : 24, containLabel: true },
          userGrid,
        ),
        tooltip: mergeOptionBlock(
          {
            trigger: 'item',
            backgroundColor: chartTooltipBg.value,
            borderColor: chartTooltipBorder.value,
            textStyle: { color: chartTooltipText.value, fontSize: 12 },
          },
          userTooltip,
        ),
        legend:
          groups.length > 1
            ? mergeOptionBlock(
                {
                  bottom: 0,
                  icon: 'circle',
                  itemWidth: 8,
                  itemHeight: 8,
                  textStyle: { fontSize: 11, color: chartTextColor.value },
                },
                userLegend,
              )
            : undefined,
        xAxis: mergeOptionBlock(
          {
            type: 'value',
            scale: true,
            splitLine: { lineStyle: { color: chartSplitLineColor.value } },
            axisLabel: { color: chartTextColor.value, fontSize: 11 },
            axisLine: { lineStyle: { color: chartAxisColor.value } },
          },
          userXAxis,
        ),
        yAxis: mergeOptionBlock(
          {
            type: 'value',
            min: -0.6,
            max: groups.length - 0.4,
            interval: 1,
            axisLabel: { color: chartTextColor.value, fontSize: 11, formatter: (v: number) => groups[Math.round(v)] ?? '' },
            splitLine: { show: false },
          },
          userYAxis,
        ),
        series: mergedSeries,
        ...userRest,
      }
    })
    </script>
    
    <template>
      <div
        role="img"
        tabindex="0"
        :aria-label="ariaLabel || 'Chart'"
        :style="{ height: /^\d+$/.test(String(height)) ? `${height}px` : String(height) }"
        :class="cn('focus-visible:ring-ring w-full focus-visible:ring-2 focus-visible:outline-none', props.class)"
      >
        <VChart :option="mergedOption" :autoresize="true" class="size-full" />
      </div>
    </template>
    
  • app/components/ui/charts/beeswarm-chart/index.ts0.1 kB
  • app/components/ui/charts/useChartTheme.ts8.2 kB

Raw manifest:https://uipkge.dev/r/vue/beeswarm-chart.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Beeswarm Chart

beeswarm-chartui

React mirror of @uipkge/beeswarm-chart — see the Vue registry item for the canonical description.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/beeswarm-chart.json
Named registry:npx shadcn@latest add @uipkge-react/beeswarm-chartInstalls to:components/ui/charts/beeswarm-chart/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
dataRecord<string, any>[]required
valueFieldstringvalueoptional
groupFieldstringgroupoptional
heightnumber | string300optional
optionanyoptional
classNamestringoptional
ariaLabel

Accessible name announced for the chart image. Defaults to "Chart".

stringoptional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

ChartTheme
interface ChartTheme {
  colors: string[]
  textColor: string
  axisColor: string
  splitLineColor: string
  tooltipBg: string
  tooltipBorder: string
  tooltipText: string
  bgColor: string
  /** The app's accent, for the one highlighted element on a chart or map —
   *  a selected route, a focused bar. Category series keep using `colors`. */
  accentColor: string
  /** Out-of-bounds / failure colour for charts that encode good vs bad
   *  rather than a category — control limits, error series. CSS-level marks
   *  can use `var(--destructive)` directly; this exists because ECharts needs
   *  a resolved colour string on the canvas. */
  dangerColor: string
}

npm dependencies

Used by

Files installed (4)

  • components/ui/charts/beeswarm-chart/BeeswarmChart.tsx3.6 kB
    'use client'
    
    import * as React from 'react'
    import { ChartFrame, EChart } from '../shared'
    import { useChartTheme, mergeOptionBlock } from '../useChartTheme'
    
    // BeeswarmChart
    // ─────────────────────────────────────────────────────────────────────────
    
    function jitter(i: number, salt: number) {
      const x = Math.sin(i * 127.1 + salt * 311.7) * 43758.5453
      return (x - Math.floor(x) - 0.5) * 0.72
    }
    
    export interface BeeswarmChartProps {
      data: Record<string, any>[]
      valueField?: string
      groupField?: string
      height?: number | string
      option?: any
      className?: string
      /** Accessible name announced for the chart image. Defaults to "Chart". */
      ariaLabel?: string
    }
    
    export const BeeswarmChart = React.forwardRef<HTMLDivElement, BeeswarmChartProps>(
      ({ data, valueField = 'value', groupField = 'group', height = 300, option, className, ariaLabel }, ref) => {
        const theme = useChartTheme()
    
        const mergedOption = React.useMemo(() => {
          const groups = [...new Set(data.map((d) => String(d[groupField])))]
          const series = groups.map((g, gi) => ({
            name: g,
            type: 'scatter',
            symbolSize: 9,
            itemStyle: { color: theme.colors[gi % theme.colors.length], opacity: 0.8 },
            data: data
              .map((d, i) => ({ d, i }))
              .filter(({ d }) => String(d[groupField]) === g)
              .map(({ d, i }) => [d[valueField], gi + jitter(i, gi)]),
          }))
          const userOption: any = option ?? {}
          const {
            series: userSeries,
            xAxis: userXAxis,
            yAxis: userYAxis,
            grid: userGrid,
            tooltip: userTooltip,
            legend: userLegend,
            ...userRest
          } = userOption
          const mergedSeries = Array.isArray(userSeries)
            ? series.map((s, i) => ({ ...s, ...(userSeries[i] ?? {}) }))
            : series
          return {
            color: theme.colors,
            grid: mergeOptionBlock(
              { left: 16, right: 16, top: 24, bottom: groups.length > 1 ? 32 : 24, containLabel: true },
              userGrid,
            ),
            tooltip: mergeOptionBlock(
              {
                trigger: 'item',
                backgroundColor: theme.tooltipBg,
                borderColor: theme.tooltipBorder,
                textStyle: { color: theme.tooltipText, fontSize: 12 },
              },
              userTooltip,
            ),
            legend:
              groups.length > 1
                ? mergeOptionBlock(
                    {
                      bottom: 0,
                      icon: 'circle',
                      itemWidth: 8,
                      itemHeight: 8,
                      textStyle: { fontSize: 11, color: theme.textColor },
                    },
                    userLegend,
                  )
                : undefined,
            xAxis: mergeOptionBlock(
              {
                type: 'value',
                scale: true,
                splitLine: { lineStyle: { color: theme.splitLineColor } },
                axisLabel: { color: theme.textColor, fontSize: 11 },
                axisLine: { lineStyle: { color: theme.axisColor } },
              },
              userXAxis,
            ),
            yAxis: mergeOptionBlock(
              {
                type: 'value',
                min: -0.6,
                max: groups.length - 0.4,
                interval: 1,
                axisLabel: { color: theme.textColor, fontSize: 11, formatter: (v: number) => groups[Math.round(v)] ?? '' },
                splitLine: { show: false },
              },
              userYAxis,
            ),
            series: mergedSeries,
            ...userRest,
          }
        }, [data, valueField, groupField, option, theme])
    
        return (
          <ChartFrame ref={ref} height={height} className={className} ariaLabel={ariaLabel}>
            <EChart option={mergedOption} />
          </ChartFrame>
        )
      },
    )
    BeeswarmChart.displayName = 'BeeswarmChart'
    
  • components/ui/charts/beeswarm-chart/index.ts0.1 kB
  • components/ui/charts/useChartTheme.ts8.7 kB
  • components/ui/charts/shared.tsx3.7 kB

Raw manifest:https://uipkge.dev/r/react/beeswarm-chart.json